# this module is a gateway between
# the task module and the server

from multiprocessing import cpu_count
from multiprocessing.managers import BaseManager
from subprocess import Popen, PIPE
from threading import Thread
import urllib2
import connection, time

class MyClient():
    def __init__(self,address,port,password):
        
        class MyManager(BaseManager): pass
        MyManager.register('get_queue')
        MyManager.register('get_command')
        MyManager.register('set_command')

        print 'Connecting to the task server '+address+':'+repr(port)
        self.manager = MyManager(address = (address,port), authkey = password)
        self.manager.connect()

        self.queue = self.manager.get_queue()
        self.command = self.manager.get_command()
        print 'Connected'

def update_command(manager,tuner):
    while True:
        line = tuner.stdout.readline()
        if ('$' in line):
            #print '---> '+line
            manager.set_command(line)
        else:
            print line

def read_queue(queue,tuner):
    while True:
        line = queue.get()
        #print '<--- '+line
        if ('$' in line):
            #print '-> '+line
            tuner.stdin.write(line+'\n')
        
if __name__ == '__main__':
    f = urllib2.urlopen('http://'+connection.TASK_ADDRESS+':8000/HTTP/Gull.cpp')
    data = f.read()
    with open("./Server/Gull.cpp", "wb") as mfile:
        mfile.write(data)

    f = urllib2.urlopen('http://'+connection.TASK_ADDRESS+':8000/HTTP/Gull.exe')
    data = f.read()
    with open("./Server/Gull.exe", "wb") as mfile:
        mfile.write(data)
    
    client = MyClient(connection.TASK_ADDRESS,connection.TASK_PORT,connection.TASK_PASSWORD)
    manager = client.manager
    queue = client.queue
    print 'Launching server'
    tuner = Popen('./Server/Gull.exe server', stdin = PIPE, stdout = PIPE)
    print 'Server launched'
    tuc = Thread(target = update_command, args=(manager,tuner))
    tuc.start()
    trq = Thread(target = read_queue, args=(queue,tuner))
    trq.start()
    
    
            
