# this module creates a daemon for storing
# a text command and a queue with results

import connection
from multiprocessing import Queue
from multiprocessing.managers import BaseManager
from os import getcwd
from shutil import copy
import SimpleHTTPServer
import SocketServer
from threading import Thread

class MyServer():
    def __init__(self,port,password):
        self.command = ''
        self.queue = Queue()
        
        class MyManager(BaseManager): pass
        MyManager.register('get_queue', callable = self.get_queue)
        MyManager.register('get_command', callable = self.get_command)
        MyManager.register('set_command', callable = self.set_command)
        
        self.manager = MyManager(address = ('',port), authkey = password)
        self.server = self.manager.get_server()
    def get_queue(self): return self.queue
    def get_command(self): return self.command
    def set_command(self,value): self.command = value
    def serve_forever(self): self.server.serve_forever()
    
def run():
    curr_dir = getcwd()
    copy(connection.CPP_LOCATION,curr_dir+'/HTTP')
    copy(connection.EXE_LOCATION,curr_dir+'/HTTP')
    Handler = SimpleHTTPServer.SimpleHTTPRequestHandler
    httpd = SocketServer.TCPServer(("", 8000), Handler)
    httpd.serve_forever()
    
if __name__ == '__main__':
    t = Thread(target = run)
    t.start()
    my_server = MyServer(20000,'qwerty')
    my_server.serve_forever()
    
